git.git: pick up latest gitweb updates
[girocco.git] / shlib.sh
blob802d7a55303c2a509d3cf7fea6bc6eb0a416cf9b
1 #!/bin/sh
3 # This is generic shell library for all the scripts used by Girocco;
4 # most importantly, it introduces all the $cfg_* shell variables.
6 # SHA-1 patterns
7 octet='[0-9a-f][0-9a-f]'
8 octet4="$octet$octet$octet$octet"
9 octet19="$octet4$octet4$octet4$octet4$octet$octet$octet"
10 octet20="$octet4$octet4$octet4$octet4$octet4"
11 nullsha="0000000000000000000000000000000000000000"
12 # tab
13 tab="$(printf '\t')"
15 # set a sane umask that never excludes any user or group permissions
16 umask $(printf '0%03o' $(( $(umask) & ~0770 )) )
18 vcmp() {
19 # Compare $1 to $2 each of which must match \d+(\.\d+)*
20 # An empty string ('') for $1 or $2 is treated like 0
21 # Outputs:
22 # -1 if $1 < $2
23 # 0 if $1 = $2
24 # 1 if $1 > $2
25 # Note that `vcmp 1.8 1.8.0.0.0.0` correctly outputs 0.
26 while
27 _a="${1%%.*}"
28 _b="${2%%.*}"
29 [ -n "$_a" -o -n "$_b" ]
31 if [ "${_a:-0}" -lt "${_b:-0}" ]; then
32 echo -1
33 return
34 elif [ "${_a:-0}" -gt "${_b:-0}" ]; then
35 echo 1
36 return
38 _a2="${1#$_a}"
39 _b2="${2#$_b}"
40 set -- "${_a2#.}" "${_b2#.}"
41 done
42 echo 0
45 get_girocco_config_pm_var_list() {
46 # Export all the variables from Girocco::Config to suitable var= lines
47 # prefixing them with 'cfg_'. E.g. $cfg_admin is admin's mail address now
48 # and also setting a 'defined_cfg_' prefix to 1 if they are not undef.
49 __girocco_conf="$GIROCCO_CONF"
50 [ -n "$__girocco_conf" ] || __girocco_conf="Girocco::Config"
51 [ -z "$basedir" ] || __girocco_extrainc="-I$basedir"
52 perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf -le \
53 'foreach (sort {uc($a) cmp uc($b)} keys %Girocco::Config::) {
54 my $val = ${$Girocco::Config::{$_}}; defined($val) or $val="";
55 $val =~ s/([\\"\$\`])/\\$1/gos;
56 $val =~ s/(?:\r\n|\r|\n)$//os;
57 print "cfg_$_=\"$val\"";
58 print "defined_cfg_$_=",
59 (defined(${$Girocco::Config::{$_}})?"1":"");
63 get_girocco_config_var_list() (
64 # Same as get_girocco_config_pm_var_list except that
65 # the following variables (all starting with var_) are added:
66 # var_group cfg_owning_group if defined otherwise `id -gn`
67 # var_git_ver The version number part from `git version`
68 # var_git_exec_path The result of $cfg_git_bin --exec-dir
69 # var_perl_bin Full path to the perl interpreter to use
70 # var_have_git_172 Set to 1 if git version >= 1.7.2 otherwise ''
71 # var_have_git_173 Set to 1 if git version >= 1.7.3 otherwise ''
72 # var_window_memory Value to use for repack --window-memory=
73 # var_big_file_threshold Value to use for core.bigFileThreshold
74 # var_redelta_threshold Recompute deltas if no more than this many objs
75 # var_log_window_size Value to use for git-svn --log-window-size=
76 # var_utf8_locale Value to use for a UTF-8 locale if available
77 # var_xargs_r A "-r" if xargs needs it to behave correctly
78 # var_du_exclude Option to exclude PATTERN from du if available
79 # var_du_follow Option to follow command line sym links if available
80 _cfg_vars="$(get_girocco_config_pm_var_list)"
81 eval "$_cfg_vars"
82 printf '%s\n' "$_cfg_vars"
83 printf 'var_group=%s\n' "${cfg_owning_group:-$(id -gn)}"
84 _gver="$("$cfg_git_bin" version 2>/dev/null | \
85 LC_ALL=C sed -ne 's/^[^0-9]*\([0-9][0-9]*\(\.[0-9][0-9]*\)*\).*$/\1/p')"
86 printf 'var_git_ver=%s\n' "$_gver"
87 printf 'var_git_exec_path="%s"\n' "$("$cfg_git_bin" --exec-path 2>/dev/null)"
88 printf 'var_perl_bin="%s"\n' "${cfg_perl_bin:-$(unset -f perl; command -v perl)}"
89 printf 'var_have_git_172=%s\n' "$([ $(vcmp "$_gver" 1.7.2) -ge 0 ] && echo 1)"
90 printf 'var_have_git_173=%s\n' "$([ $(vcmp "$_gver" 1.7.3) -ge 0 ] && echo 1)"
91 __girocco_conf="$GIROCCO_CONF"
92 [ -n "$__girocco_conf" ] || __girocco_conf="Girocco::Config"
93 [ -z "$basedir" ] || __girocco_extrainc="-I$basedir"
94 printf "var_window_memory=%s\n" \
95 "$(perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf \
96 -MGirocco::Util -e 'print calc_windowmemory')"
97 printf "var_big_file_threshold=%s\n" \
98 "$(perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf \
99 -MGirocco::Util -e 'print calc_bigfilethreshold')"
100 printf "var_redelta_threshold=%s\n" \
101 "$(perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf \
102 -MGirocco::Util -e 'print calc_redeltathreshold')"
103 printf 'var_log_window_size=%s\n' "${cfg_svn_log_window_size:-250}"
104 # We parse the output of `locale -a` and select a suitable UTF-8 locale.
105 _guess_locale="$(locale -a | LC_ALL=C grep -viE '^(posix|c)(\..*)?$' | \
106 LC_ALL=C grep -iE '\.utf-?8$' | LC_ALL=C sed -e 's/\.[Uu][Tt][Ff]-*8$//' | \
107 LC_ALL=C sed -e '/en_US/ s/^/0 /; /en_US/ !s/^/1 /' | LC_ALL=C sort | \
108 head -n 1 | LC_ALL=C cut -d ' ' -f 2)"
109 [ -z "$_guess_locale" ] || printf 'var_utf8_locale=%s.UTF-8\n' "$_guess_locale"
110 # On some broken platforms running xargs without -r and empty input runs the command
111 printf 'var_xargs_r=%s\n' "$(: | command xargs echo -r)"
112 # The disk usage report produces better numbers if du has an exclude option
113 _x0="$(basename "$0")"
114 _x0="${_x0%?}?*"
115 for _duopt in --exclude -I; do
116 if _test="$(du $_duopt 's?lib.s*' $_duopt "$_x0" "$0" 2>/dev/null)" && [ -z "$_test" ]; then
117 printf 'var_du_exclude=%s\n' "$_duopt"
118 break
120 done
121 if _test="$(du -H "$0" 2>/dev/null)" && [ -n "$_test" ]; then
122 printf 'var_du_follow=%s\n' "-H"
123 break
127 # If basedir has been replaced, and shlib_vars.sh exists, get the config
128 # definitions from it rather than running Perl.
129 if [ "@basedir@" = '@'basedir'@' ] || ! [ -r "@basedir@/shlib_vars.sh" ]; then
130 # Import all the variables from Girocco::Config to the local environment,
131 eval "$(get_girocco_config_var_list)"
132 else
133 # Import the variables from shlib_vars.sh which avoids needlessly
134 # running another copy of Perl
135 . "@basedir@/shlib_vars.sh"
138 # git_add_config "some.var=value"
139 # every ' in value must be replaced with the 4-character sequence '\'' before
140 # calling this function or Git will barf. Will not be effective unless running
141 # Git version 1.7.3 or later.
142 git_add_config() {
143 GIT_CONFIG_PARAMETERS="${GIT_CONFIG_PARAMETERS:+$GIT_CONFIG_PARAMETERS }'$1'"
144 export GIT_CONFIG_PARAMETERS
147 # Make sure we have a reproducible environment by using a controlled HOME dir
148 XDG_CONFIG_HOME="$cfg_chroot/var/empty"
149 HOME="$cfg_chroot/etc/girocco"
150 TMPDIR="/tmp"
151 GIT_CONFIG_NOSYSTEM=1
152 GIT_ATTR_NOSYSTEM=1
153 GIT_NO_REPLACE_OBJECTS=1
154 GIT_TERMINAL_PROMPT=0
155 GIT_ASKPASS="$cfg_basedir/bin/git-askpass-password"
156 export XDG_CONFIG_HOME
157 export HOME
158 export TMPDIR
159 export GIT_CONFIG_NOSYSTEM
160 export GIT_ATTR_NOSYSTEM
161 export GIT_NO_REPLACE_OBJECTS
162 export GIT_TERMINAL_PROMPT
163 export GIT_ASKPASS
164 unset GIT_USER_AGENT
165 unset GIT_HTTP_USER_AGENT
166 if [ -n "$defined_cfg_git_client_ua" ]; then
167 GIT_USER_AGENT="$cfg_git_client_ua"
168 export GIT_USER_AGENT
169 GIT_HTTP_USER_AGENT="$cfg_git_client_ua"
170 export GIT_HTTP_USER_AGENT
172 unset GIT_CONFIG_PARAMETERS
173 [ -z "$var_big_file_threshold" ] ||
174 git_add_config "core.bigFileThreshold=$var_big_file_threshold"
176 # We cannot use a git() {} or nc_openbsd() {} function to redirect git
177 # and nc_openbsd to the desired executables because when using
178 # "ENV_VAR=xxx func" the various /bin/sh implementations behave in various
179 # different and unexpected ways:
180 # a) treat "ENV_VAR=xxx" like a separate, preceding "export ENV_VAR=xxx"
181 # b) treat "ENV_VAR=xxx" like a separate, prededing "ENV_VAR=xxx"
182 # c) treat "ENV_VAR=xxx" like a temporary setting only while running func
183 # None of these are good. We want a temporary "export ENV_VAR=xxx"
184 # setting only while running func which none of the /bin/sh's do.
186 # Instead we'd like to use an alias that provides the desired behavior without
187 # any of the bad (a), (b) or (c) effects.
189 # However, unfortunately, some of the crazy /bin/sh implementations do not
190 # recognize alias expansions when preceded by variable assignments!
192 # So we are left with git() {} and nc_openbsd() {} functions and in the
193 # case of git() {} we can compensate for (b) and (c) failing to export
194 # but not (a) and (b) persisting the values so the caller will simply
195 # have to beware and explicitly unset any variables that should not persist
196 # beyond the function call itself.
198 git() (
199 [ "${GIT_DIR+set}" = "set" ] && export GIT_DIR
200 [ "${GIT_SSL_NO_VERIFY+set}" = "set" ] && export GIT_SSL_NO_VERIFY
201 [ "${GIT_TRACE_PACKET+set}" = "set" ] && export GIT_TRACE_PACKET
202 [ "${GIT_USER_AGENT+set}" = "set" ] && export GIT_USER_AGENT
203 [ "${GIT_HTTP_USER_AGENT+set}" = "set" ] && export GIT_HTTP_USER_AGENT
204 exec "$cfg_git_bin" "$@"
207 # see comments for git() -- callers must explicitly export all variables
208 # intended for the perl interpreter before using this function
209 perl() { command "${var_perl_bin:-perl}" "$@"; }
211 nc_openbsd() { "$cfg_nc_openbsd_bin" "$@"; }
213 list_packs() { command "$cfg_basedir/bin/list_packs" "$@"; }
215 strftime() { command "$cfg_basedir/bin/strftime" "$@"; }
217 # Some platforms' broken xargs runs the command always at least once even if
218 # there's no input unless given a special option. Automatically supply the
219 # option on those platforms by providing an xargs function.
220 xargs() { command xargs $var_xargs_r "$@"; }
222 _addrlist() {
223 _list=
224 for _addr in "$@"; do
225 [ -z "$_list" ] || _list="$_list, "
226 _list="$_list$_addr"
227 done
228 echo "$_list"
231 _sendmail() {
232 _mailer="${cfg_sendmail_bin:-/usr/sbin/sendmail}"
233 if [ -n "$cfg_sender" ]; then
234 "$_mailer" -i -f "$cfg_sender" "$@"
235 else
236 "$_mailer" -i "$@"
240 mail() {
241 _subject=
242 if [ "$1" = "-s" ]; then
243 shift
244 _subject="$1"
245 shift
248 echo "From: \"$cfg_name\" ($cfg_title) <$cfg_admin>"
249 echo "To: $(_addrlist "$@")"
250 [ -z "$_subject" ] || echo "Subject: $_subject"
251 echo "MIME-Version: 1.0"
252 echo "Content-Type: text/plain; charset=utf-8"
253 echo "Content-Transfer-Encoding: 8bit"
254 [ -n "$cfg_suppress_x_girocco" ] || echo "X-Girocco: $cfg_gitweburl"
255 echo "Auto-Submitted: auto-generated"
256 echo ""
258 } | _sendmail "$@"
261 # bang CMD... will execute the command with well-defined failure mode;
262 # set bang_action to string of the failed action ('clone', 'update', ...);
263 # pre-set bang_once=1 to make sure jobs banging on a repo repeatedly will
264 # not spam the owner; re-define the bang_trap() function to do custom
265 # cleanup before bailing out
266 bang() {
267 if [ -n "$show_progress" ]; then
268 exec 3>&1
269 errcode=
270 read -r errcode <<-EOT || :
272 exec 4>&3 3>&1 1>&4 4>&-
273 { "$@" 3>&- || echo $? >&3; } 2>&1 | tee -a "$bang_log"
276 exec 3>&-
277 if [ -z "$errcode" ]; then
278 # All right. Cool.
279 return;
281 else
282 if "$@" >>"$bang_log" 2>&1; then
283 # All right. Cool.
284 return;
285 else
286 errcode="$?"
289 if ! [ -e .banged ] || [ -e .bangagain ]; then
290 rm -f .bangagain
291 bangmailok=true
292 ! [ -f HEAD -a -f config -a -d objects ] ||
293 bangmailok="$(GIT_DIR=. git config --bool gitweb.statusupdates 2>/dev/null || echo true)"
294 bangaddrs=''
295 [ "$bangmailok" = "false" -o -z "$mail" ] || bangaddrs="$mail"
296 [ -z "$cfg_admincc" -o "$cfg_admincc" = "0" -o -z "$cfg_admin" ] ||
297 if [ -z "$bangaddrs" ]; then bangaddrs="$cfg_admin"; else bangaddrs="$bangaddrs,$cfg_admin"; fi
298 [ -z "$bangaddrs" ] ||
300 echo "$* failed with error code $errcode"
301 echo ""
302 [ ! -n "$bang_once" ] || echo "you will not receive any more notifications until recovery"
303 echo "this status message may be disabled on the project admin page"
304 echo ""
305 echo "Log follows:"
306 echo ""
307 cat "$bang_log"
308 } | mail -s "[$cfg_name] $proj $bang_action failed" "$bangaddrs"
310 touch .banged
311 cat "$bang_log" > .banglog
312 bang_trap
313 exit 1
316 # bang_eval CMD... will evaluate the command with well-defined failure mode;
317 # Identical to bang CMD... except the command is eval'd instead of executed.
318 bang_eval() {
319 bang eval "$*"
322 # Default bang settings:
323 bang_setup() {
324 bang_action="lame_programmer"
325 bang_once=
326 bang_trap() { :; }
327 bang_log="$(mktemp -t repomgr-XXXXXX)"
328 trap 'rm -f "$bang_log"' EXIT
329 trap 'exit 130' INT
330 trap 'exit 143' TERM
333 # Remove banged status
334 bang_reset() {
335 rm -f .banged .bangagain .banglog
338 # Check to see if banged status
339 is_banged() {
340 [ -e .banged ]
344 # Progress report - if show_progress is set, shows the given message.
345 progress() {
346 [ ! -n "$show_progress" ] || echo "$@"
350 # Project config accessors; must be run in project directory
351 config_get() {
352 git config "gitweb.$1"
355 config_set() {
356 git config "gitweb.$1" "$2" && chgrp $var_group config && chmod g+w config
359 config_set_raw() {
360 git config "$1" "$2" && chgrp $var_group config && chmod g+w config
363 config_get_date_seconds() {
364 _dt="$(config_get "$1" || :)"
365 [ -n "$_dt" ] || return 1
366 _ds="$(perl -I@basedir@ -MGirocco::Util -e "print parse_rfc2822_date('$_dt')")"
367 [ -n "$_ds" ] || return 1
368 echo "$_ds"
371 # Tool for checking whether given number of seconds has not passed yet
372 check_interval() {
373 os="$(config_get_date_seconds "$1")" || return 1
374 ns="$(date +%s)"
375 [ $ns -lt $(($os+$2)) ]
378 # Check if we are running with effective root permissions
379 is_root() {
380 [ "$(id -u 2>/dev/null)" = "0" ]
383 # Check to see if the single argument is a Git directory
384 is_git_dir() {
385 # Just like Git's test except we ignore GIT_OBJECT_DIRECTORY
386 # And we are slightly more picky (must be refs/.+ not refs/.*)
387 [ -d "$1/objects" -a -x "$1/objects" ] || return 1
388 [ -d "$1/refs" -a -x "$1/refs" ] || return 1
389 if [ -L "$1/HEAD" ]; then
390 _hr="$(readlink "$1/HEAD")"
391 case "$_hr" in "refs/"?*) :;; *) return 1;; esac
393 [ -f "$1/HEAD" -a -r "$1/HEAD" ] || return 1
394 read -r _hr <"$1/HEAD" || return 1
395 case "$_hr" in
396 $octet20)
397 return 0;;
398 ref:*)
399 _hr="${_hr##ref:*[ $tab]}"
400 case "$_hr" in "refs/"?*) return 0;; esac
401 esac
402 return 1
405 # List all Git repositories, with given prefix if specified, one-per-line
406 # All project names starting with _ are always excluded from the result
407 get_repo_list() {
408 if [ -n "$1" ]; then
409 LC_ALL=C cut -d : -f 1,3 "$cfg_chroot"/etc/group | LC_ALL=C grep "^$1"
410 else
411 LC_ALL=C cut -d : -f 1,3 "$cfg_chroot"/etc/group
412 fi | while IFS=: read name id; do
413 [ $id -lt 65536 ] || case "$name" in _*) :;; ?*) echo "$name"; esac
414 done
417 # Return success if the given project name has any forks
418 has_forks() {
419 _prj="${1%.git}"
420 [ -n "$_prj" ] || return 1
421 [ -d "$cfg_reporoot/$_prj" ] || return 1
422 is_git_dir "$cfg_reporoot/$_prj.git" || return 1
423 test $(get_repo_list "$_prj/[^/][^/]*:" | LC_ALL=C wc -l) -gt 0
426 # returns empty string and error for empty string otherwise one of
427 # m => normal Git mirror
428 # s => mirror from svn source
429 # d => mirror from darcs source
430 # b => mirror from bzr source
431 # h => mirror from hg source
432 # w => mirror from mediawiki source
433 # f => mirror from other fast-import source
434 # note that if the string is non-empty and none of s, d, b or h match the
435 # return will always be type m regardless of whether it's a valid Git URL
436 get_url_mirror_type() {
437 case "$1" in
439 return 1
441 svn://* | svn+http://* | svn+https://* | svn+file://* | svn+ssh://*)
442 echo 's'
444 darcs://*)
445 echo 'd'
447 bzr://*)
448 echo 'b'
450 hg+http://* | hg+https://* | hg+file://* | hg+ssh://* | hg::*)
451 echo 'h'
453 mediawiki::*)
454 echo 'w'
457 echo 'm'
459 esac
460 return 0
463 # returns false for empty string
464 # returns true if the passed in url is a mirror using git fast-import
465 is_gfi_mirror_url() {
466 [ -n "$1" ] || return 1
467 case "$(get_url_mirror_type "$1" 2>/dev/null || :)" in
468 d|b|h|w|f)
469 # darcs, bzr, hg and mediawiki mirrors use git fast-import
470 # and so do generic "f" fast-import mirrors
471 return 0
474 # Don't think git-svn currently uses git fast-import
475 # And Git mirrors certainly do not
476 return 1
478 esac
479 # assume it does not use git fast-import
480 return 1
483 # returns mirror url for gitweb.baseurl of git directory
484 # (GIT_DIR) passed in as the argument (which defaults to "." if omitted)
485 # will fail if the directory does not have .nofetch and gitweb.baseurl
486 # comes back empty -- otherwise .nofetch directories succeed with a "" return
487 # automatically strips any leading "disabled " prefix before returning result
488 get_mirror_url() {
489 _gitdir="${1:-.}"
490 # always return empty for non-mirrors
491 [ ! -e "$_gitdir/.nofetch" ] || return 0
492 _url="$(GIT_DIR="$_gitdir" config_get baseurl 2>/dev/null || :)"
493 _url="${_url##* }"
494 [ -n "$_url" ] || return 1
495 printf '%s\n' "$_url"
496 return 0
499 # returns get_url_mirror_type for gitweb.baseurl of git directory
500 # (GIT_DIR) passed in as the argument (which defaults to "." if omitted)
501 # will fail if the directory does not have .nofetch and gitweb.baseurl
502 # comes back empty -- otherwise .nofetch directories succeed with a "" return
503 # automatically strips any leading "disabled " prefix before testing
504 get_mirror_type() {
505 _url="$(get_mirror_url "$@")" || return 1
506 get_url_mirror_type "$_url"
509 # returns true if the passed in git dir (defaults to ".") is a mirror using git fast-import
510 is_gfi_mirror() {
511 _url="$(get_mirror_url "$@")" || return 1
512 is_gfi_mirror_url "$_url"
515 # returns true if the passed in git dir (defaults to ".") is a mirror using git-svn
516 is_svn_mirror() {
517 [ "$(get_mirror_type "$1" 2>/dev/null || :)" = "s" ]
520 # A well-known UTF-8 locale is required for some of the fast-import providers
521 # in order to avoid mangling characters. Ideally we could use "POSIX.UTF-8"
522 # but that is not reliably UTF-8 but rather usually US-ASCII.
523 # We parse the output of `locale -a` and select a suitable UTF-8 locale at
524 # install time and store that in $var_utf8_locale if one is found.
525 # If we cannot find one in the `locale -a` output then we just use a well-known
526 # UTF-8 locale and hope for the best. We set LC_ALL to our choice and export
527 # it. We only set this temporarily when running the fast-import providers.
528 set_utf8_locale() {
529 LC_ALL="${var_utf8_locale:-en_US.UTF-8}"
530 export LC_ALL
533 # hg-fast-export | git fast-import with error handling in current directory GIT_DIR
534 git_hg_fetch() (
535 set_utf8_locale
536 _python="${PYTHON:-python}"
537 [ -e hg2git-marks ] || >hg2git-marks
538 rm -f hg2git-marks.new
539 _err1=
540 _err2=
541 exec 3>&1
542 { read -r _err1 || :; read -r _err2 || :; } <<-EOT
544 exec 4>&3 3>&1 1>&4 4>&-
546 _e1=0
547 _af="$(git config hg.authorsfile || :)"
548 _cmd='GIT_DIR="$(pwd)" "$_python" "$cfg_basedir/bin/hg-fast-export.py" \
549 --repo "$(pwd)/repo.hg" \
550 --marks "$(pwd)/hg2git-marks" \
551 --mapping "$(pwd)/hg2git-mapping" \
552 --heads "$(pwd)/hg2git-heads" \
553 --status "$(pwd)/hg2git-state" \
554 -U unknown --force --flatten --hg-hash'
555 [ -z "$_af" ] || _cmd="$_cmd"' --authors "$_af"'
556 eval "$_cmd" 3>&- || _e1=$?
557 echo $_e1 >&3
558 } | \
560 _e2=0
561 git fast-import \
562 --import-marks="$(pwd)/hg2git-marks" \
563 --export-marks="$(pwd)/hg2git-marks.new" \
564 --export-pack-edges="$(pwd)/gfi-packs" \
565 --force 3>&- || _e2=$?
566 echo $_e2 >&3
570 exec 3>&-
571 [ "$_err1" = 0 -a "$_err2" = 0 ] || return 1
572 mv -f hg2git-marks.new hg2git-marks
573 git for-each-ref --format='%(refname) %(objectname)' refs/heads | \
574 LC_ALL=C sed -e 's,^refs/heads/,:,' >hg2git-heads